//Crypto module for GMod by Hexxeh
#include "GMLuaModule.h"
#include "md5wrapper.h"
#include "sha1.h"
#include <sstream>
#include <iomanip>

using namespace std;

GMOD_MODULE(Init, Shutdown);

LUA_FUNCTION(md5) {
	const char* plaintext = g_Lua->GetString(1);
	md5wrapper md5;
	string hashed = md5.getHashFromString(plaintext);
	g_Lua->Push(hashed.c_str());
	return 1;
}

LUA_FUNCTION(sha1) {
	const char* plaintext = g_Lua->GetString(1);
	SHA1* sha1 = new SHA1();
	sha1->addBytes(plaintext, strlen(plaintext));
	unsigned char* digest = sha1->getDigest();
	ostringstream text;
	for (int i=0; i<20; ++i) {
		text << setfill('0') << setw(2) << hex << (int)digest[i];
	}
	g_Lua->Push(text.str().c_str());
	delete sha1;
	free(digest);
	return 1;
}

int Init(void) {
	Msg("gm_crypto has loaded!\n");

	g_Lua->NewGlobalTable("crypto");
	ILuaObject* table = g_Lua->GetGlobal("crypto");
		table->SetMember("md5", md5);
		table->SetMember("sha1", sha1);
	SAFE_UNREF( table );

	return 0;
}

int Shutdown(void) {
	return 0;
}